library BCD2A;

uses
  SysUtils,
  Windows,
  Classes,
  Controls,
  Dlg_BCD2A in 'Dlg_BCD2A.pas' {BCD2ADLG};

{$R *.RES}

Const  Inputs = 8;  // number of inputs
       Outputs = 1; // number of outputs made adjustable

       {INPUTS}
       X0   = 0;   // index of input variable
       X1   = 1;   // index of input variable
       X2   = 2;   // index of input variable
       X3   = 3;   // index of input variable
       X4   = 4;   // index of input variable
       X5   = 5;   // index of input variable
       X6   = 6;   // index of input variable
       X7   = 7;   // index of input variable

       {OUTPUTS}
       BCD    = 0;

       {USER}
       SELECT = 0;

       DLLINDEX = 100;

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

function NumInputs: Byte;
begin
  result:= Inputs; //Define FIXED number of component input pins
end;

function NumOutputs: Byte; // Made adjustable with 'NumOutputsEx'
begin
  result:= Outputs; //Define FIXED number of component output pins
end;

function NumOutputsEx(PUser: PDLLParams): Byte;
begin

end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
  result:='X' + intToStr(Channel);
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
   result:='A';
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams); //called when ProfiLab enters RUN mode
begin
  // nothing to be done
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
end;

Procedure Calculate(PInput,POutput,PUser: PDLLParams); //called regularly from ProfiLab
var l_VALUE : longint;
    n       : Integer;
begin
  l_VALUE:= 0;
  if (PInput[X0] > 2.5) then l_VALUE:= l_VALUE or $01;
  if (PInput[X1] > 2.5) then l_VALUE:= l_VALUE or $02;
  if (PInput[X2] > 2.5) then l_VALUE:= l_VALUE or $04;
  if (PInput[X3] > 2.5) then l_VALUE:= l_VALUE or $08;
  if (PInput[X4] > 2.5) then l_VALUE:= l_VALUE or $10;
  if (PInput[X5] > 2.5) then l_VALUE:= l_VALUE or $20;
  if (PInput[X6] > 2.5) then l_VALUE:= l_VALUE or $40;
  if (PInput[X7] > 2.5) then l_VALUE:= l_VALUE or $80;

  n:= round(PUser^[SELECT]);

  case n of
  0: begin
     end;
  1: begin
       l_VALUE:= l_VALUE shl 8;
     end;
  2: begin
       l_VALUE:= l_VALUE shl 16;
     end;
  3: begin
       l_VALUE:= l_VALUE shl 24;
     end;
  end; //case

  POutput[BCD]:= l_VALUE;
end;

Procedure Configure(PUser: PDLLParams);
var DLG: TBCD2ADLG;
begin
   DLG:=TBCD2ADLG.Create(nil);                       //Create user dialogue
   With DLG do
   begin
      Caption:='Counter [DLL'+FloatToStr(PUser^[DLLIndex])+']'; // Show ProfiLab DLL-Index in dialogue caption
      BitsCombo.ItemIndex:=round(PUser^[SELECT]);       // Set dialogue values

      if ShowModal = mrOK then                                 // Execute dialogue
      begin
         PUser^[SELECT]:= BitsCombo.ItemIndex;           // Read back values from dialogue;
      end;

      free;                                                  // Dont forget to free dialogue
   end;
end;


//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        Calculate,
        InputName,
        OutputName,
        Configure;
begin
end.

